export abstract class Gamesystem<S, T> {
  gamesystemName: string
  gamesystemDescription: string

  states: S[] = [];
  transitions: T[] = [];
  constructor(gamesystemName: string) {
    this.gamesystemName = gamesystemName;
    this.gamesystemDescription = "";
  }

  abstract createState(label: string, description: string): S|undefined;

  abstract createTransition(startingState: S, endingState: S): T|undefined;

  abstract removeState(state: S): boolean;

  removeTransition(transition: T): boolean {
    const updatedTransitions = this.transitions.filter(t => t !== transition);
    if(updatedTransitions.length == this.transitions.length) {
      return false;
    }

    this.transitions = updatedTransitions;
    return true;
  }


}
